module Proy2 where

import Test.QuickCheck
import Control.Monad (liftM, liftM2, liftM3)

-- ejercicio 1 a)

data Titulo = Ducado | Marquesado | Condado
            | Vizcondado | Baronia deriving Show

dama :: Titulo -> String
dama Ducado = "duquesa"
dama Marquesado = "marquesa"
dama Condado = "condesa"
dama Vizcondado = "vizcondesa"
dama Baronia = "baronesa"

-- ejercicio 1 b)

type Territorio = String
type Nombre = String

data Persona = Rey | Noble Titulo Territorio | Caballero Nombre
             | Aldeano Nombre deriving Show

personaAStr :: Persona -> String
personaAStr Rey = "Su majestad el rey"
personaAStr (Noble tit terr) = "El " ++ show tit ++ " de " ++ show terr
personaAStr (Caballero nom) = "Sir " ++ nom
personaAStr (Aldeano nom) = nom


instance Arbitrary Titulo where
  arbitrary = elements [Ducado, Marquesado, Condado, Vizcondado, Baronia]

instance Arbitrary Persona where
    arbitrary = do
        n <- choose (1,4) :: Gen Int
        case n of
            1 -> return Rey
            2 -> do tit <- arbitrary
                    ter <- arbitrary
                    return (Noble tit ter)
            3 -> do nom <- arbitrary
                    return (Caballero nom)
            4 -> do nom <- arbitrary
                    return (Aldeano nom)

-- instance Arbitrary Persona where
-- arbitrary =
--      oneof [ return Rey
--            , liftM2 Noble arbitrary arbitrary
--            , liftM Caballero arbitrary
--            , liftM Aldeano arbitrary
--            ]

-------------------------------------------------
-- la cantidad de sirs es menor o igual al total:
prop_sirs :: [Persona] -> Bool
prop_sirs ps = length (sirs ps) <= length ps
-------------------------------------------------

sirs :: [Persona] -> [String]
sirs [] = []
sirs ((Caballero n):ps) = n : sirs ps
sirs (p:ps) = sirs ps

-- ejercicio 3

data ListAssoc a b = Empty | Node a b (ListAssoc a b) deriving Show

la_length :: Integral c => ListAssoc a b -> c
la_length Empty = 0
la_length (Node _ _ la) = 1 + la_length la

la_search :: Eq a => ListAssoc a b -> a -> Maybe b
la_search Empty _ = Nothing
la_search (Node k d la ) k' | k == k' = Just d
                            | otherwise = la_search la k'

la_toListPair :: ListAssoc a b -> [(a,b)]
la_toListPair Empty = []
la_toListPair (Node k d la) = (k,d):la_toListPair la

--------------------------------------------------------------
-- Checkear con una función de búsqueda modelo:
prop_la :: ListAssoc Int String -> Int -> Bool
prop_la la k = la_search la k == lookup k (la_toListPair la)
--------------------------------------------------------------

instance (Arbitrary a, Arbitrary b) => Arbitrary (ListAssoc a b) where
    arbitrary = do
        n <- choose (1,2) :: Gen Int
        case n of
            1 -> return Empty
            2 -> do a <- arbitrary
                    b <- arbitrary
                    list <- arbitrary
                    return (Node a b list)

-- instance (Arbitrary a, Arbitrary b) => Arbitrary (ListAssoc a b) where
--     arbitrary =
--         oneof   [ return Empty
--                 , liftM3 Node arbitrary arbitrary arbitrary
--                 ]

-- Función para testear:
verbCheck :: (Testable prop) => prop -> IO ()
verbCheck = verboseCheckWith miargs
          where
          miargs = Args { replay = Nothing
                        , maxSuccess = 100
                        , maxDiscard = 100
                        , maxSize = 1000
                        , chatty = True}

